{
  "contractName": "SafeTransferLib",
  "abi": [
    {
      "inputs": [],
      "name": "ApproveFailed",
      "type": "error"
    },
    {
      "inputs": [],
      "name": "ETHTransferFailed",
      "type": "error"
    },
    {
      "inputs": [],
      "name": "TransferFailed",
      "type": "error"
    },
    {
      "inputs": [],
      "name": "TransferFromFailed",
      "type": "error"
    }
  ],
  "metadata": "{\"compiler\":{\"version\":\"0.8.28+commit.7893614a\"},\"language\":\"Solidity\",\"output\":{\"abi\":[{\"inputs\":[],\"name\":\"ApproveFailed\",\"type\":\"error\"},{\"inputs\":[],\"name\":\"ETHTransferFailed\",\"type\":\"error\"},{\"inputs\":[],\"name\":\"TransferFailed\",\"type\":\"error\"},{\"inputs\":[],\"name\":\"TransferFromFailed\",\"type\":\"error\"}],\"devdoc\":{\"author\":\"SolDAO (https://github.com/Sol-DAO/solbase/blob/main/src/utils/SafeTransferLib.sol)Modified from Solady (https://github.com/vectorized/solady/blob/main/src/utils/SafeTransferLib.sol)\",\"details\":\"Caution! This library won't check that a token has code, responsibility is delegated to the caller.\",\"errors\":{\"ApproveFailed()\":[{\"details\":\"The ERC20 `approve` has failed.\"}],\"ETHTransferFailed()\":[{\"details\":\"The ETH transfer has failed.\"}],\"TransferFailed()\":[{\"details\":\"The ERC20 `transfer` has failed.\"}],\"TransferFromFailed()\":[{\"details\":\"The ERC20 `transferFrom` has failed.\"}]},\"kind\":\"dev\",\"methods\":{},\"version\":1},\"userdoc\":{\"kind\":\"user\",\"methods\":{},\"notice\":\"Safe ETH and ERC20 transfer library that gracefully handles missing return values.\",\"version\":1}},\"settings\":{\"compilationTarget\":{\"project:/contracts/SafeTransferLib.sol\":\"SafeTransferLib\"},\"evmVersion\":\"shanghai\",\"libraries\":{},\"metadata\":{\"bytecodeHash\":\"ipfs\"},\"optimizer\":{\"enabled\":true,\"runs\":200},\"remappings\":[]},\"sources\":{\"project:/contracts/SafeTransferLib.sol\":{\"keccak256\":\"0xb0500234799f59758b44c78ed63166f2b64a5d8c0c19024fd85208508656164f\",\"license\":\"MIT\",\"urls\":[\"bzz-raw://f66a271b4ebee7032c91876874f54773a35955249b912621c7321502a365d417\",\"dweb:/ipfs/QmVkYb24oB8BKCebkrQG6eNubX55eUDsyFF7vNTepFjLPi\"]}},\"version\":1}",
  "bytecode": "0x60556032600b8282823980515f1a607314602657634e487b7160e01b5f525f60045260245ffd5b305f52607381538281f3fe730000000000000000000000000000000000000000301460806040525f5ffdfea2646970667358221220b8e4c54956b78eb1d902472d8bcd780699e2498febb06efde0fc9f05db3916a364736f6c634300081c0033",
  "deployedBytecode": "0x730000000000000000000000000000000000000000301460806040525f5ffdfea2646970667358221220b8e4c54956b78eb1d902472d8bcd780699e2498febb06efde0fc9f05db3916a364736f6c634300081c0033",
  "immutableReferences": {},
  "generatedSources": [],
  "deployedGeneratedSources": [],
  "sourceMap": "469:6578:5:-:0;;;;;;;;;;;;;;;-1:-1:-1;;;469:6578:5;;;;;;;;;;;;;;;;;",
  "deployedSourceMap": "469:6578:5:-:0;;;;;;;;",
  "source": "// SPDX-License-Identifier: MIT\npragma solidity ^0.8.4;\n\n/// @notice Safe ETH and ERC20 transfer library that gracefully handles missing return values.\n/// @author SolDAO (https://github.com/Sol-DAO/solbase/blob/main/src/utils/SafeTransferLib.sol)\n/// @author Modified from Solady (https://github.com/vectorized/solady/blob/main/src/utils/SafeTransferLib.sol)\n/// @dev Caution! This library won't check that a token has code, responsibility is delegated to the caller.\nlibrary SafeTransferLib {\n    /// -----------------------------------------------------------------------\n    /// Custom Errors\n    /// -----------------------------------------------------------------------\n\n    /// @dev The ETH transfer has failed.\n    error ETHTransferFailed();\n\n    /// @dev The ERC20 `approve` has failed.\n    error ApproveFailed();\n\n    /// @dev The ERC20 `transfer` has failed.\n    error TransferFailed();\n\n    /// @dev The ERC20 `transferFrom` has failed.\n    error TransferFromFailed();\n\n    /// -----------------------------------------------------------------------\n    /// ETH Operations\n    /// -----------------------------------------------------------------------\n\n    /// @dev Sends `amount` (in wei) ETH to `to`.\n    /// Reverts upon failure.\n    function safeTransferETH(address to, uint256 amount) internal {\n        /// @solidity memory-safe-assembly\n        assembly {\n            // Transfer the ETH and check if it succeeded or not.\n            if iszero(call(gas(), to, amount, 0, 0, 0, 0)) {\n                // Store the function selector of `ETHTransferFailed()`.\n                mstore(0x00, 0xb12d13eb)\n                // Revert with (offset, size).\n                revert(0x1c, 0x04)\n            }\n        }\n    }\n\n    /// -----------------------------------------------------------------------\n    /// ERC20 Operations\n    /// -----------------------------------------------------------------------\n\n    /// @dev Sets `amount` of ERC20 `token` for `to` to manage on behalf of the current contract.\n    /// Reverts upon failure.\n    function safeApprove(address token, address to, uint256 amount) internal {\n        /// @solidity memory-safe-assembly\n        assembly {\n            // We'll write our calldata to this slot below, but restore it later.\n            let memPointer := mload(0x40)\n\n            // Write the abi-encoded calldata into memory, beginning with the function selector.\n            mstore(0x00, 0x095ea7b3)\n            mstore(0x20, to) // Append the \"to\" argument.\n            mstore(0x40, amount) // Append the \"amount\" argument.\n\n            if iszero(\n                and(\n                    // Set success to whether the call reverted, if not we check it either\n                    // returned exactly 1 (can't just be non-zero data), or had no return data.\n                    or(eq(mload(0x00), 1), iszero(returndatasize())),\n                    // We use 0x44 because that's the total length of our calldata (0x04 + 0x20 * 2)\n                    // Counterintuitively, this call() must be positioned after the or() in the\n                    // surrounding and() because and() evaluates its arguments from right to left.\n                    call(gas(), token, 0, 0x1c, 0x44, 0x00, 0x20)\n                )\n            ) {\n                // Store the function selector of `ApproveFailed()`.\n                mstore(0x00, 0x3e3f8f73)\n                // Revert with (offset, size).\n                revert(0x1c, 0x04)\n            }\n\n            mstore(0x40, memPointer) // Restore the memPointer.\n        }\n    }\n\n    /// @dev Sends `amount` of ERC20 `token` from the current contract to `to`.\n    /// Reverts upon failure.\n    function safeTransfer(address token, address to, uint256 amount) internal {\n        /// @solidity memory-safe-assembly\n        assembly {\n            // We'll write our calldata to this slot below, but restore it later.\n            let memPointer := mload(0x40)\n\n            // Write the abi-encoded calldata into memory, beginning with the function selector.\n            mstore(0x00, 0xa9059cbb)\n            mstore(0x20, to) // Append the \"to\" argument.\n            mstore(0x40, amount) // Append the \"amount\" argument.\n\n            if iszero(\n                and(\n                    // Set success to whether the call reverted, if not we check it either\n                    // returned exactly 1 (can't just be non-zero data), or had no return data.\n                    or(eq(mload(0x00), 1), iszero(returndatasize())),\n                    // We use 0x44 because that's the total length of our calldata (0x04 + 0x20 * 2)\n                    // Counterintuitively, this call() must be positioned after the or() in the\n                    // surrounding and() because and() evaluates its arguments from right to left.\n                    call(gas(), token, 0, 0x1c, 0x44, 0x00, 0x20)\n                )\n            ) {\n                // Store the function selector of `TransferFailed()`.\n                mstore(0x00, 0x90b8ec18)\n                // Revert with (offset, size).\n                revert(0x1c, 0x04)\n            }\n\n            mstore(0x40, memPointer) // Restore the memPointer.\n        }\n    }\n\n    /// @dev Sends `amount` of ERC20 `token` from `from` to `to`.\n    /// Reverts upon failure.\n    ///\n    /// The `from` account must have at least `amount` approved for\n    /// the current contract to manage.\n    function safeTransferFrom(address token, address from, address to, uint256 amount) internal {\n        /// @solidity memory-safe-assembly\n        assembly {\n            // We'll write our calldata to this slot below, but restore it later.\n            let memPointer := mload(0x40)\n\n            // Write the abi-encoded calldata into memory, beginning with the function selector.\n            mstore(0x00, 0x23b872dd)\n            mstore(0x20, from) // Append the \"from\" argument.\n            mstore(0x40, to) // Append the \"to\" argument.\n            mstore(0x60, amount) // Append the \"amount\" argument.\n\n            if iszero(\n                and(\n                    // Set success to whether the call reverted, if not we check it either\n                    // returned exactly 1 (can't just be non-zero data), or had no return data.\n                    or(eq(mload(0x00), 1), iszero(returndatasize())),\n                    // We use 0x64 because that's the total length of our calldata (0x04 + 0x20 * 3)\n                    // Counterintuitively, this call() must be positioned after the or() in the\n                    // surrounding and() because and() evaluates its arguments from right to left.\n                    call(gas(), token, 0, 0x1c, 0x64, 0x00, 0x20)\n                )\n            ) {\n                // Store the function selector of `TransferFromFailed()`.\n                mstore(0x00, 0x7939f424)\n                // Revert with (offset, size).\n                revert(0x1c, 0x04)\n            }\n\n            mstore(0x60, 0) // Restore the zero slot to zero.\n            mstore(0x40, memPointer) // Restore the memPointer.\n        }\n    }\n}\n",
  "sourcePath": "/home/ensh/dapp/truffle/contracts/SafeTransferLib.sol",
  "ast": {
    "absolutePath": "project:/contracts/SafeTransferLib.sol",
    "exportedSymbols": {
      "SafeTransferLib": [
        7894
      ]
    },
    "id": 7895,
    "license": "MIT",
    "nodeType": "SourceUnit",
    "nodes": [
      {
        "id": 7832,
        "literals": [
          "solidity",
          "^",
          "0.8",
          ".4"
        ],
        "nodeType": "PragmaDirective",
        "src": "32:23:5"
      },
      {
        "abstract": false,
        "baseContracts": [],
        "canonicalName": "SafeTransferLib",
        "contractDependencies": [],
        "contractKind": "library",
        "documentation": {
          "id": 7833,
          "nodeType": "StructuredDocumentation",
          "src": "57:412:5",
          "text": "@notice Safe ETH and ERC20 transfer library that gracefully handles missing return values.\n @author SolDAO (https://github.com/Sol-DAO/solbase/blob/main/src/utils/SafeTransferLib.sol)\n @author Modified from Solady (https://github.com/vectorized/solady/blob/main/src/utils/SafeTransferLib.sol)\n @dev Caution! This library won't check that a token has code, responsibility is delegated to the caller."
        },
        "fullyImplemented": true,
        "id": 7894,
        "linearizedBaseContracts": [
          7894
        ],
        "name": "SafeTransferLib",
        "nameLocation": "477:15:5",
        "nodeType": "ContractDefinition",
        "nodes": [
          {
            "documentation": {
              "id": 7834,
              "nodeType": "StructuredDocumentation",
              "src": "682:37:5",
              "text": "@dev The ETH transfer has failed."
            },
            "errorSelector": "b12d13eb",
            "id": 7836,
            "name": "ETHTransferFailed",
            "nameLocation": "730:17:5",
            "nodeType": "ErrorDefinition",
            "parameters": {
              "id": 7835,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "747:2:5"
            },
            "src": "724:26:5"
          },
          {
            "documentation": {
              "id": 7837,
              "nodeType": "StructuredDocumentation",
              "src": "756:40:5",
              "text": "@dev The ERC20 `approve` has failed."
            },
            "errorSelector": "3e3f8f73",
            "id": 7839,
            "name": "ApproveFailed",
            "nameLocation": "807:13:5",
            "nodeType": "ErrorDefinition",
            "parameters": {
              "id": 7838,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "820:2:5"
            },
            "src": "801:22:5"
          },
          {
            "documentation": {
              "id": 7840,
              "nodeType": "StructuredDocumentation",
              "src": "829:41:5",
              "text": "@dev The ERC20 `transfer` has failed."
            },
            "errorSelector": "90b8ec18",
            "id": 7842,
            "name": "TransferFailed",
            "nameLocation": "881:14:5",
            "nodeType": "ErrorDefinition",
            "parameters": {
              "id": 7841,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "895:2:5"
            },
            "src": "875:23:5"
          },
          {
            "documentation": {
              "id": 7843,
              "nodeType": "StructuredDocumentation",
              "src": "904:45:5",
              "text": "@dev The ERC20 `transferFrom` has failed."
            },
            "errorSelector": "7939f424",
            "id": 7845,
            "name": "TransferFromFailed",
            "nameLocation": "960:18:5",
            "nodeType": "ErrorDefinition",
            "parameters": {
              "id": 7844,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "978:2:5"
            },
            "src": "954:27:5"
          },
          {
            "body": {
              "id": 7854,
              "nodeType": "Block",
              "src": "1313:416:5",
              "statements": [
                {
                  "AST": {
                    "nativeSrc": "1375:348:5",
                    "nodeType": "YulBlock",
                    "src": "1375:348:5",
                    "statements": [
                      {
                        "body": {
                          "nativeSrc": "1502:211:5",
                          "nodeType": "YulBlock",
                          "src": "1502:211:5",
                          "statements": [
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "1600:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "1600:4:5",
                                    "type": "",
                                    "value": "0x00"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "1606:10:5",
                                    "nodeType": "YulLiteral",
                                    "src": "1606:10:5",
                                    "type": "",
                                    "value": "0xb12d13eb"
                                  }
                                ],
                                "functionName": {
                                  "name": "mstore",
                                  "nativeSrc": "1593:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "1593:6:5"
                                },
                                "nativeSrc": "1593:24:5",
                                "nodeType": "YulFunctionCall",
                                "src": "1593:24:5"
                              },
                              "nativeSrc": "1593:24:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "1593:24:5"
                            },
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "1688:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "1688:4:5",
                                    "type": "",
                                    "value": "0x1c"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "1694:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "1694:4:5",
                                    "type": "",
                                    "value": "0x04"
                                  }
                                ],
                                "functionName": {
                                  "name": "revert",
                                  "nativeSrc": "1681:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "1681:6:5"
                                },
                                "nativeSrc": "1681:18:5",
                                "nodeType": "YulFunctionCall",
                                "src": "1681:18:5"
                              },
                              "nativeSrc": "1681:18:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "1681:18:5"
                            }
                          ]
                        },
                        "condition": {
                          "arguments": [
                            {
                              "arguments": [
                                {
                                  "arguments": [],
                                  "functionName": {
                                    "name": "gas",
                                    "nativeSrc": "1470:3:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "1470:3:5"
                                  },
                                  "nativeSrc": "1470:5:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "1470:5:5"
                                },
                                {
                                  "name": "to",
                                  "nativeSrc": "1477:2:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "1477:2:5"
                                },
                                {
                                  "name": "amount",
                                  "nativeSrc": "1481:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "1481:6:5"
                                },
                                {
                                  "kind": "number",
                                  "nativeSrc": "1489:1:5",
                                  "nodeType": "YulLiteral",
                                  "src": "1489:1:5",
                                  "type": "",
                                  "value": "0"
                                },
                                {
                                  "kind": "number",
                                  "nativeSrc": "1492:1:5",
                                  "nodeType": "YulLiteral",
                                  "src": "1492:1:5",
                                  "type": "",
                                  "value": "0"
                                },
                                {
                                  "kind": "number",
                                  "nativeSrc": "1495:1:5",
                                  "nodeType": "YulLiteral",
                                  "src": "1495:1:5",
                                  "type": "",
                                  "value": "0"
                                },
                                {
                                  "kind": "number",
                                  "nativeSrc": "1498:1:5",
                                  "nodeType": "YulLiteral",
                                  "src": "1498:1:5",
                                  "type": "",
                                  "value": "0"
                                }
                              ],
                              "functionName": {
                                "name": "call",
                                "nativeSrc": "1465:4:5",
                                "nodeType": "YulIdentifier",
                                "src": "1465:4:5"
                              },
                              "nativeSrc": "1465:35:5",
                              "nodeType": "YulFunctionCall",
                              "src": "1465:35:5"
                            }
                          ],
                          "functionName": {
                            "name": "iszero",
                            "nativeSrc": "1458:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "1458:6:5"
                          },
                          "nativeSrc": "1458:43:5",
                          "nodeType": "YulFunctionCall",
                          "src": "1458:43:5"
                        },
                        "nativeSrc": "1455:258:5",
                        "nodeType": "YulIf",
                        "src": "1455:258:5"
                      }
                    ]
                  },
                  "documentation": "@solidity memory-safe-assembly",
                  "evmVersion": "shanghai",
                  "externalReferences": [
                    {
                      "declaration": 7850,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "1481:6:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7848,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "1477:2:5",
                      "valueSize": 1
                    }
                  ],
                  "id": 7853,
                  "nodeType": "InlineAssembly",
                  "src": "1366:357:5"
                }
              ]
            },
            "documentation": {
              "id": 7846,
              "nodeType": "StructuredDocumentation",
              "src": "1171:75:5",
              "text": "@dev Sends `amount` (in wei) ETH to `to`.\n Reverts upon failure."
            },
            "id": 7855,
            "implemented": true,
            "kind": "function",
            "modifiers": [],
            "name": "safeTransferETH",
            "nameLocation": "1260:15:5",
            "nodeType": "FunctionDefinition",
            "parameters": {
              "id": 7851,
              "nodeType": "ParameterList",
              "parameters": [
                {
                  "constant": false,
                  "id": 7848,
                  "mutability": "mutable",
                  "name": "to",
                  "nameLocation": "1284:2:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7855,
                  "src": "1276:10:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7847,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "1276:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7850,
                  "mutability": "mutable",
                  "name": "amount",
                  "nameLocation": "1296:6:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7855,
                  "src": "1288:14:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_uint256",
                    "typeString": "uint256"
                  },
                  "typeName": {
                    "id": 7849,
                    "name": "uint256",
                    "nodeType": "ElementaryTypeName",
                    "src": "1288:7:5",
                    "typeDescriptions": {
                      "typeIdentifier": "t_uint256",
                      "typeString": "uint256"
                    }
                  },
                  "visibility": "internal"
                }
              ],
              "src": "1275:28:5"
            },
            "returnParameters": {
              "id": 7852,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "1313:0:5"
            },
            "scope": 7894,
            "src": "1251:478:5",
            "stateMutability": "nonpayable",
            "virtual": false,
            "visibility": "internal"
          },
          {
            "body": {
              "id": 7866,
              "nodeType": "Block",
              "src": "2122:1431:5",
              "statements": [
                {
                  "AST": {
                    "nativeSrc": "2184:1363:5",
                    "nodeType": "YulBlock",
                    "src": "2184:1363:5",
                    "statements": [
                      {
                        "nativeSrc": "2280:29:5",
                        "nodeType": "YulVariableDeclaration",
                        "src": "2280:29:5",
                        "value": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "2304:4:5",
                              "nodeType": "YulLiteral",
                              "src": "2304:4:5",
                              "type": "",
                              "value": "0x40"
                            }
                          ],
                          "functionName": {
                            "name": "mload",
                            "nativeSrc": "2298:5:5",
                            "nodeType": "YulIdentifier",
                            "src": "2298:5:5"
                          },
                          "nativeSrc": "2298:11:5",
                          "nodeType": "YulFunctionCall",
                          "src": "2298:11:5"
                        },
                        "variables": [
                          {
                            "name": "memPointer",
                            "nativeSrc": "2284:10:5",
                            "nodeType": "YulTypedName",
                            "src": "2284:10:5",
                            "type": ""
                          }
                        ]
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "2427:4:5",
                              "nodeType": "YulLiteral",
                              "src": "2427:4:5",
                              "type": "",
                              "value": "0x00"
                            },
                            {
                              "kind": "number",
                              "nativeSrc": "2433:10:5",
                              "nodeType": "YulLiteral",
                              "src": "2433:10:5",
                              "type": "",
                              "value": "0x095ea7b3"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "2420:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "2420:6:5"
                          },
                          "nativeSrc": "2420:24:5",
                          "nodeType": "YulFunctionCall",
                          "src": "2420:24:5"
                        },
                        "nativeSrc": "2420:24:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "2420:24:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "2464:4:5",
                              "nodeType": "YulLiteral",
                              "src": "2464:4:5",
                              "type": "",
                              "value": "0x20"
                            },
                            {
                              "name": "to",
                              "nativeSrc": "2470:2:5",
                              "nodeType": "YulIdentifier",
                              "src": "2470:2:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "2457:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "2457:6:5"
                          },
                          "nativeSrc": "2457:16:5",
                          "nodeType": "YulFunctionCall",
                          "src": "2457:16:5"
                        },
                        "nativeSrc": "2457:16:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "2457:16:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "2522:4:5",
                              "nodeType": "YulLiteral",
                              "src": "2522:4:5",
                              "type": "",
                              "value": "0x40"
                            },
                            {
                              "name": "amount",
                              "nativeSrc": "2528:6:5",
                              "nodeType": "YulIdentifier",
                              "src": "2528:6:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "2515:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "2515:6:5"
                          },
                          "nativeSrc": "2515:20:5",
                          "nodeType": "YulFunctionCall",
                          "src": "2515:20:5"
                        },
                        "nativeSrc": "2515:20:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "2515:20:5"
                      },
                      {
                        "body": {
                          "nativeSrc": "3265:207:5",
                          "nodeType": "YulBlock",
                          "src": "3265:207:5",
                          "statements": [
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "3359:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "3359:4:5",
                                    "type": "",
                                    "value": "0x00"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "3365:10:5",
                                    "nodeType": "YulLiteral",
                                    "src": "3365:10:5",
                                    "type": "",
                                    "value": "0x3e3f8f73"
                                  }
                                ],
                                "functionName": {
                                  "name": "mstore",
                                  "nativeSrc": "3352:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "3352:6:5"
                                },
                                "nativeSrc": "3352:24:5",
                                "nodeType": "YulFunctionCall",
                                "src": "3352:24:5"
                              },
                              "nativeSrc": "3352:24:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "3352:24:5"
                            },
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "3447:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "3447:4:5",
                                    "type": "",
                                    "value": "0x1c"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "3453:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "3453:4:5",
                                    "type": "",
                                    "value": "0x04"
                                  }
                                ],
                                "functionName": {
                                  "name": "revert",
                                  "nativeSrc": "3440:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "3440:6:5"
                                },
                                "nativeSrc": "3440:18:5",
                                "nodeType": "YulFunctionCall",
                                "src": "3440:18:5"
                              },
                              "nativeSrc": "3440:18:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "3440:18:5"
                            }
                          ]
                        },
                        "condition": {
                          "arguments": [
                            {
                              "arguments": [
                                {
                                  "arguments": [
                                    {
                                      "arguments": [
                                        {
                                          "arguments": [
                                            {
                                              "kind": "number",
                                              "nativeSrc": "2833:4:5",
                                              "nodeType": "YulLiteral",
                                              "src": "2833:4:5",
                                              "type": "",
                                              "value": "0x00"
                                            }
                                          ],
                                          "functionName": {
                                            "name": "mload",
                                            "nativeSrc": "2827:5:5",
                                            "nodeType": "YulIdentifier",
                                            "src": "2827:5:5"
                                          },
                                          "nativeSrc": "2827:11:5",
                                          "nodeType": "YulFunctionCall",
                                          "src": "2827:11:5"
                                        },
                                        {
                                          "kind": "number",
                                          "nativeSrc": "2840:1:5",
                                          "nodeType": "YulLiteral",
                                          "src": "2840:1:5",
                                          "type": "",
                                          "value": "1"
                                        }
                                      ],
                                      "functionName": {
                                        "name": "eq",
                                        "nativeSrc": "2824:2:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "2824:2:5"
                                      },
                                      "nativeSrc": "2824:18:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "2824:18:5"
                                    },
                                    {
                                      "arguments": [
                                        {
                                          "arguments": [],
                                          "functionName": {
                                            "name": "returndatasize",
                                            "nativeSrc": "2851:14:5",
                                            "nodeType": "YulIdentifier",
                                            "src": "2851:14:5"
                                          },
                                          "nativeSrc": "2851:16:5",
                                          "nodeType": "YulFunctionCall",
                                          "src": "2851:16:5"
                                        }
                                      ],
                                      "functionName": {
                                        "name": "iszero",
                                        "nativeSrc": "2844:6:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "2844:6:5"
                                      },
                                      "nativeSrc": "2844:24:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "2844:24:5"
                                    }
                                  ],
                                  "functionName": {
                                    "name": "or",
                                    "nativeSrc": "2821:2:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "2821:2:5"
                                  },
                                  "nativeSrc": "2821:48:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "2821:48:5"
                                },
                                {
                                  "arguments": [
                                    {
                                      "arguments": [],
                                      "functionName": {
                                        "name": "gas",
                                        "nativeSrc": "3192:3:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "3192:3:5"
                                      },
                                      "nativeSrc": "3192:5:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "3192:5:5"
                                    },
                                    {
                                      "name": "token",
                                      "nativeSrc": "3199:5:5",
                                      "nodeType": "YulIdentifier",
                                      "src": "3199:5:5"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "3206:1:5",
                                      "nodeType": "YulLiteral",
                                      "src": "3206:1:5",
                                      "type": "",
                                      "value": "0"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "3209:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "3209:4:5",
                                      "type": "",
                                      "value": "0x1c"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "3215:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "3215:4:5",
                                      "type": "",
                                      "value": "0x44"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "3221:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "3221:4:5",
                                      "type": "",
                                      "value": "0x00"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "3227:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "3227:4:5",
                                      "type": "",
                                      "value": "0x20"
                                    }
                                  ],
                                  "functionName": {
                                    "name": "call",
                                    "nativeSrc": "3187:4:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "3187:4:5"
                                  },
                                  "nativeSrc": "3187:45:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "3187:45:5"
                                }
                              ],
                              "functionName": {
                                "name": "and",
                                "nativeSrc": "2609:3:5",
                                "nodeType": "YulIdentifier",
                                "src": "2609:3:5"
                              },
                              "nativeSrc": "2609:641:5",
                              "nodeType": "YulFunctionCall",
                              "src": "2609:641:5"
                            }
                          ],
                          "functionName": {
                            "name": "iszero",
                            "nativeSrc": "2585:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "2585:6:5"
                          },
                          "nativeSrc": "2585:679:5",
                          "nodeType": "YulFunctionCall",
                          "src": "2585:679:5"
                        },
                        "nativeSrc": "2582:890:5",
                        "nodeType": "YulIf",
                        "src": "2582:890:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "3493:4:5",
                              "nodeType": "YulLiteral",
                              "src": "3493:4:5",
                              "type": "",
                              "value": "0x40"
                            },
                            {
                              "name": "memPointer",
                              "nativeSrc": "3499:10:5",
                              "nodeType": "YulIdentifier",
                              "src": "3499:10:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "3486:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "3486:6:5"
                          },
                          "nativeSrc": "3486:24:5",
                          "nodeType": "YulFunctionCall",
                          "src": "3486:24:5"
                        },
                        "nativeSrc": "3486:24:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "3486:24:5"
                      }
                    ]
                  },
                  "documentation": "@solidity memory-safe-assembly",
                  "evmVersion": "shanghai",
                  "externalReferences": [
                    {
                      "declaration": 7862,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "2528:6:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7860,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "2470:2:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7858,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "3199:5:5",
                      "valueSize": 1
                    }
                  ],
                  "id": 7865,
                  "nodeType": "InlineAssembly",
                  "src": "2175:1372:5"
                }
              ]
            },
            "documentation": {
              "id": 7856,
              "nodeType": "StructuredDocumentation",
              "src": "1921:123:5",
              "text": "@dev Sets `amount` of ERC20 `token` for `to` to manage on behalf of the current contract.\n Reverts upon failure."
            },
            "id": 7867,
            "implemented": true,
            "kind": "function",
            "modifiers": [],
            "name": "safeApprove",
            "nameLocation": "2058:11:5",
            "nodeType": "FunctionDefinition",
            "parameters": {
              "id": 7863,
              "nodeType": "ParameterList",
              "parameters": [
                {
                  "constant": false,
                  "id": 7858,
                  "mutability": "mutable",
                  "name": "token",
                  "nameLocation": "2078:5:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7867,
                  "src": "2070:13:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7857,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "2070:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7860,
                  "mutability": "mutable",
                  "name": "to",
                  "nameLocation": "2093:2:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7867,
                  "src": "2085:10:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7859,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "2085:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7862,
                  "mutability": "mutable",
                  "name": "amount",
                  "nameLocation": "2105:6:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7867,
                  "src": "2097:14:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_uint256",
                    "typeString": "uint256"
                  },
                  "typeName": {
                    "id": 7861,
                    "name": "uint256",
                    "nodeType": "ElementaryTypeName",
                    "src": "2097:7:5",
                    "typeDescriptions": {
                      "typeIdentifier": "t_uint256",
                      "typeString": "uint256"
                    }
                  },
                  "visibility": "internal"
                }
              ],
              "src": "2069:43:5"
            },
            "returnParameters": {
              "id": 7864,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "2122:0:5"
            },
            "scope": 7894,
            "src": "2049:1504:5",
            "stateMutability": "nonpayable",
            "virtual": false,
            "visibility": "internal"
          },
          {
            "body": {
              "id": 7878,
              "nodeType": "Block",
              "src": "3743:1432:5",
              "statements": [
                {
                  "AST": {
                    "nativeSrc": "3805:1364:5",
                    "nodeType": "YulBlock",
                    "src": "3805:1364:5",
                    "statements": [
                      {
                        "nativeSrc": "3901:29:5",
                        "nodeType": "YulVariableDeclaration",
                        "src": "3901:29:5",
                        "value": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "3925:4:5",
                              "nodeType": "YulLiteral",
                              "src": "3925:4:5",
                              "type": "",
                              "value": "0x40"
                            }
                          ],
                          "functionName": {
                            "name": "mload",
                            "nativeSrc": "3919:5:5",
                            "nodeType": "YulIdentifier",
                            "src": "3919:5:5"
                          },
                          "nativeSrc": "3919:11:5",
                          "nodeType": "YulFunctionCall",
                          "src": "3919:11:5"
                        },
                        "variables": [
                          {
                            "name": "memPointer",
                            "nativeSrc": "3905:10:5",
                            "nodeType": "YulTypedName",
                            "src": "3905:10:5",
                            "type": ""
                          }
                        ]
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "4048:4:5",
                              "nodeType": "YulLiteral",
                              "src": "4048:4:5",
                              "type": "",
                              "value": "0x00"
                            },
                            {
                              "kind": "number",
                              "nativeSrc": "4054:10:5",
                              "nodeType": "YulLiteral",
                              "src": "4054:10:5",
                              "type": "",
                              "value": "0xa9059cbb"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "4041:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "4041:6:5"
                          },
                          "nativeSrc": "4041:24:5",
                          "nodeType": "YulFunctionCall",
                          "src": "4041:24:5"
                        },
                        "nativeSrc": "4041:24:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "4041:24:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "4085:4:5",
                              "nodeType": "YulLiteral",
                              "src": "4085:4:5",
                              "type": "",
                              "value": "0x20"
                            },
                            {
                              "name": "to",
                              "nativeSrc": "4091:2:5",
                              "nodeType": "YulIdentifier",
                              "src": "4091:2:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "4078:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "4078:6:5"
                          },
                          "nativeSrc": "4078:16:5",
                          "nodeType": "YulFunctionCall",
                          "src": "4078:16:5"
                        },
                        "nativeSrc": "4078:16:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "4078:16:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "4143:4:5",
                              "nodeType": "YulLiteral",
                              "src": "4143:4:5",
                              "type": "",
                              "value": "0x40"
                            },
                            {
                              "name": "amount",
                              "nativeSrc": "4149:6:5",
                              "nodeType": "YulIdentifier",
                              "src": "4149:6:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "4136:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "4136:6:5"
                          },
                          "nativeSrc": "4136:20:5",
                          "nodeType": "YulFunctionCall",
                          "src": "4136:20:5"
                        },
                        "nativeSrc": "4136:20:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "4136:20:5"
                      },
                      {
                        "body": {
                          "nativeSrc": "4886:208:5",
                          "nodeType": "YulBlock",
                          "src": "4886:208:5",
                          "statements": [
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "4981:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "4981:4:5",
                                    "type": "",
                                    "value": "0x00"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "4987:10:5",
                                    "nodeType": "YulLiteral",
                                    "src": "4987:10:5",
                                    "type": "",
                                    "value": "0x90b8ec18"
                                  }
                                ],
                                "functionName": {
                                  "name": "mstore",
                                  "nativeSrc": "4974:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "4974:6:5"
                                },
                                "nativeSrc": "4974:24:5",
                                "nodeType": "YulFunctionCall",
                                "src": "4974:24:5"
                              },
                              "nativeSrc": "4974:24:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "4974:24:5"
                            },
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "5069:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "5069:4:5",
                                    "type": "",
                                    "value": "0x1c"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "5075:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "5075:4:5",
                                    "type": "",
                                    "value": "0x04"
                                  }
                                ],
                                "functionName": {
                                  "name": "revert",
                                  "nativeSrc": "5062:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "5062:6:5"
                                },
                                "nativeSrc": "5062:18:5",
                                "nodeType": "YulFunctionCall",
                                "src": "5062:18:5"
                              },
                              "nativeSrc": "5062:18:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "5062:18:5"
                            }
                          ]
                        },
                        "condition": {
                          "arguments": [
                            {
                              "arguments": [
                                {
                                  "arguments": [
                                    {
                                      "arguments": [
                                        {
                                          "arguments": [
                                            {
                                              "kind": "number",
                                              "nativeSrc": "4454:4:5",
                                              "nodeType": "YulLiteral",
                                              "src": "4454:4:5",
                                              "type": "",
                                              "value": "0x00"
                                            }
                                          ],
                                          "functionName": {
                                            "name": "mload",
                                            "nativeSrc": "4448:5:5",
                                            "nodeType": "YulIdentifier",
                                            "src": "4448:5:5"
                                          },
                                          "nativeSrc": "4448:11:5",
                                          "nodeType": "YulFunctionCall",
                                          "src": "4448:11:5"
                                        },
                                        {
                                          "kind": "number",
                                          "nativeSrc": "4461:1:5",
                                          "nodeType": "YulLiteral",
                                          "src": "4461:1:5",
                                          "type": "",
                                          "value": "1"
                                        }
                                      ],
                                      "functionName": {
                                        "name": "eq",
                                        "nativeSrc": "4445:2:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "4445:2:5"
                                      },
                                      "nativeSrc": "4445:18:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "4445:18:5"
                                    },
                                    {
                                      "arguments": [
                                        {
                                          "arguments": [],
                                          "functionName": {
                                            "name": "returndatasize",
                                            "nativeSrc": "4472:14:5",
                                            "nodeType": "YulIdentifier",
                                            "src": "4472:14:5"
                                          },
                                          "nativeSrc": "4472:16:5",
                                          "nodeType": "YulFunctionCall",
                                          "src": "4472:16:5"
                                        }
                                      ],
                                      "functionName": {
                                        "name": "iszero",
                                        "nativeSrc": "4465:6:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "4465:6:5"
                                      },
                                      "nativeSrc": "4465:24:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "4465:24:5"
                                    }
                                  ],
                                  "functionName": {
                                    "name": "or",
                                    "nativeSrc": "4442:2:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "4442:2:5"
                                  },
                                  "nativeSrc": "4442:48:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "4442:48:5"
                                },
                                {
                                  "arguments": [
                                    {
                                      "arguments": [],
                                      "functionName": {
                                        "name": "gas",
                                        "nativeSrc": "4813:3:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "4813:3:5"
                                      },
                                      "nativeSrc": "4813:5:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "4813:5:5"
                                    },
                                    {
                                      "name": "token",
                                      "nativeSrc": "4820:5:5",
                                      "nodeType": "YulIdentifier",
                                      "src": "4820:5:5"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "4827:1:5",
                                      "nodeType": "YulLiteral",
                                      "src": "4827:1:5",
                                      "type": "",
                                      "value": "0"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "4830:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "4830:4:5",
                                      "type": "",
                                      "value": "0x1c"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "4836:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "4836:4:5",
                                      "type": "",
                                      "value": "0x44"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "4842:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "4842:4:5",
                                      "type": "",
                                      "value": "0x00"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "4848:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "4848:4:5",
                                      "type": "",
                                      "value": "0x20"
                                    }
                                  ],
                                  "functionName": {
                                    "name": "call",
                                    "nativeSrc": "4808:4:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "4808:4:5"
                                  },
                                  "nativeSrc": "4808:45:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "4808:45:5"
                                }
                              ],
                              "functionName": {
                                "name": "and",
                                "nativeSrc": "4230:3:5",
                                "nodeType": "YulIdentifier",
                                "src": "4230:3:5"
                              },
                              "nativeSrc": "4230:641:5",
                              "nodeType": "YulFunctionCall",
                              "src": "4230:641:5"
                            }
                          ],
                          "functionName": {
                            "name": "iszero",
                            "nativeSrc": "4206:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "4206:6:5"
                          },
                          "nativeSrc": "4206:679:5",
                          "nodeType": "YulFunctionCall",
                          "src": "4206:679:5"
                        },
                        "nativeSrc": "4203:891:5",
                        "nodeType": "YulIf",
                        "src": "4203:891:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "5115:4:5",
                              "nodeType": "YulLiteral",
                              "src": "5115:4:5",
                              "type": "",
                              "value": "0x40"
                            },
                            {
                              "name": "memPointer",
                              "nativeSrc": "5121:10:5",
                              "nodeType": "YulIdentifier",
                              "src": "5121:10:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "5108:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "5108:6:5"
                          },
                          "nativeSrc": "5108:24:5",
                          "nodeType": "YulFunctionCall",
                          "src": "5108:24:5"
                        },
                        "nativeSrc": "5108:24:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "5108:24:5"
                      }
                    ]
                  },
                  "documentation": "@solidity memory-safe-assembly",
                  "evmVersion": "shanghai",
                  "externalReferences": [
                    {
                      "declaration": 7874,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "4149:6:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7872,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "4091:2:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7870,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "4820:5:5",
                      "valueSize": 1
                    }
                  ],
                  "id": 7877,
                  "nodeType": "InlineAssembly",
                  "src": "3796:1373:5"
                }
              ]
            },
            "documentation": {
              "id": 7868,
              "nodeType": "StructuredDocumentation",
              "src": "3559:105:5",
              "text": "@dev Sends `amount` of ERC20 `token` from the current contract to `to`.\n Reverts upon failure."
            },
            "id": 7879,
            "implemented": true,
            "kind": "function",
            "modifiers": [],
            "name": "safeTransfer",
            "nameLocation": "3678:12:5",
            "nodeType": "FunctionDefinition",
            "parameters": {
              "id": 7875,
              "nodeType": "ParameterList",
              "parameters": [
                {
                  "constant": false,
                  "id": 7870,
                  "mutability": "mutable",
                  "name": "token",
                  "nameLocation": "3699:5:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7879,
                  "src": "3691:13:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7869,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "3691:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7872,
                  "mutability": "mutable",
                  "name": "to",
                  "nameLocation": "3714:2:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7879,
                  "src": "3706:10:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7871,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "3706:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7874,
                  "mutability": "mutable",
                  "name": "amount",
                  "nameLocation": "3726:6:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7879,
                  "src": "3718:14:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_uint256",
                    "typeString": "uint256"
                  },
                  "typeName": {
                    "id": 7873,
                    "name": "uint256",
                    "nodeType": "ElementaryTypeName",
                    "src": "3718:7:5",
                    "typeDescriptions": {
                      "typeIdentifier": "t_uint256",
                      "typeString": "uint256"
                    }
                  },
                  "visibility": "internal"
                }
              ],
              "src": "3690:43:5"
            },
            "returnParameters": {
              "id": 7876,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "3743:0:5"
            },
            "scope": 7894,
            "src": "3669:1506:5",
            "stateMutability": "nonpayable",
            "virtual": false,
            "visibility": "internal"
          },
          {
            "body": {
              "id": 7892,
              "nodeType": "Block",
              "src": "5485:1560:5",
              "statements": [
                {
                  "AST": {
                    "nativeSrc": "5547:1492:5",
                    "nodeType": "YulBlock",
                    "src": "5547:1492:5",
                    "statements": [
                      {
                        "nativeSrc": "5643:29:5",
                        "nodeType": "YulVariableDeclaration",
                        "src": "5643:29:5",
                        "value": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "5667:4:5",
                              "nodeType": "YulLiteral",
                              "src": "5667:4:5",
                              "type": "",
                              "value": "0x40"
                            }
                          ],
                          "functionName": {
                            "name": "mload",
                            "nativeSrc": "5661:5:5",
                            "nodeType": "YulIdentifier",
                            "src": "5661:5:5"
                          },
                          "nativeSrc": "5661:11:5",
                          "nodeType": "YulFunctionCall",
                          "src": "5661:11:5"
                        },
                        "variables": [
                          {
                            "name": "memPointer",
                            "nativeSrc": "5647:10:5",
                            "nodeType": "YulTypedName",
                            "src": "5647:10:5",
                            "type": ""
                          }
                        ]
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "5790:4:5",
                              "nodeType": "YulLiteral",
                              "src": "5790:4:5",
                              "type": "",
                              "value": "0x00"
                            },
                            {
                              "kind": "number",
                              "nativeSrc": "5796:10:5",
                              "nodeType": "YulLiteral",
                              "src": "5796:10:5",
                              "type": "",
                              "value": "0x23b872dd"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "5783:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "5783:6:5"
                          },
                          "nativeSrc": "5783:24:5",
                          "nodeType": "YulFunctionCall",
                          "src": "5783:24:5"
                        },
                        "nativeSrc": "5783:24:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "5783:24:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "5827:4:5",
                              "nodeType": "YulLiteral",
                              "src": "5827:4:5",
                              "type": "",
                              "value": "0x20"
                            },
                            {
                              "name": "from",
                              "nativeSrc": "5833:4:5",
                              "nodeType": "YulIdentifier",
                              "src": "5833:4:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "5820:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "5820:6:5"
                          },
                          "nativeSrc": "5820:18:5",
                          "nodeType": "YulFunctionCall",
                          "src": "5820:18:5"
                        },
                        "nativeSrc": "5820:18:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "5820:18:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "5889:4:5",
                              "nodeType": "YulLiteral",
                              "src": "5889:4:5",
                              "type": "",
                              "value": "0x40"
                            },
                            {
                              "name": "to",
                              "nativeSrc": "5895:2:5",
                              "nodeType": "YulIdentifier",
                              "src": "5895:2:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "5882:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "5882:6:5"
                          },
                          "nativeSrc": "5882:16:5",
                          "nodeType": "YulFunctionCall",
                          "src": "5882:16:5"
                        },
                        "nativeSrc": "5882:16:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "5882:16:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "5947:4:5",
                              "nodeType": "YulLiteral",
                              "src": "5947:4:5",
                              "type": "",
                              "value": "0x60"
                            },
                            {
                              "name": "amount",
                              "nativeSrc": "5953:6:5",
                              "nodeType": "YulIdentifier",
                              "src": "5953:6:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "5940:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "5940:6:5"
                          },
                          "nativeSrc": "5940:20:5",
                          "nodeType": "YulFunctionCall",
                          "src": "5940:20:5"
                        },
                        "nativeSrc": "5940:20:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "5940:20:5"
                      },
                      {
                        "body": {
                          "nativeSrc": "6690:212:5",
                          "nodeType": "YulBlock",
                          "src": "6690:212:5",
                          "statements": [
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "6789:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "6789:4:5",
                                    "type": "",
                                    "value": "0x00"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "6795:10:5",
                                    "nodeType": "YulLiteral",
                                    "src": "6795:10:5",
                                    "type": "",
                                    "value": "0x7939f424"
                                  }
                                ],
                                "functionName": {
                                  "name": "mstore",
                                  "nativeSrc": "6782:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "6782:6:5"
                                },
                                "nativeSrc": "6782:24:5",
                                "nodeType": "YulFunctionCall",
                                "src": "6782:24:5"
                              },
                              "nativeSrc": "6782:24:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "6782:24:5"
                            },
                            {
                              "expression": {
                                "arguments": [
                                  {
                                    "kind": "number",
                                    "nativeSrc": "6877:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "6877:4:5",
                                    "type": "",
                                    "value": "0x1c"
                                  },
                                  {
                                    "kind": "number",
                                    "nativeSrc": "6883:4:5",
                                    "nodeType": "YulLiteral",
                                    "src": "6883:4:5",
                                    "type": "",
                                    "value": "0x04"
                                  }
                                ],
                                "functionName": {
                                  "name": "revert",
                                  "nativeSrc": "6870:6:5",
                                  "nodeType": "YulIdentifier",
                                  "src": "6870:6:5"
                                },
                                "nativeSrc": "6870:18:5",
                                "nodeType": "YulFunctionCall",
                                "src": "6870:18:5"
                              },
                              "nativeSrc": "6870:18:5",
                              "nodeType": "YulExpressionStatement",
                              "src": "6870:18:5"
                            }
                          ]
                        },
                        "condition": {
                          "arguments": [
                            {
                              "arguments": [
                                {
                                  "arguments": [
                                    {
                                      "arguments": [
                                        {
                                          "arguments": [
                                            {
                                              "kind": "number",
                                              "nativeSrc": "6258:4:5",
                                              "nodeType": "YulLiteral",
                                              "src": "6258:4:5",
                                              "type": "",
                                              "value": "0x00"
                                            }
                                          ],
                                          "functionName": {
                                            "name": "mload",
                                            "nativeSrc": "6252:5:5",
                                            "nodeType": "YulIdentifier",
                                            "src": "6252:5:5"
                                          },
                                          "nativeSrc": "6252:11:5",
                                          "nodeType": "YulFunctionCall",
                                          "src": "6252:11:5"
                                        },
                                        {
                                          "kind": "number",
                                          "nativeSrc": "6265:1:5",
                                          "nodeType": "YulLiteral",
                                          "src": "6265:1:5",
                                          "type": "",
                                          "value": "1"
                                        }
                                      ],
                                      "functionName": {
                                        "name": "eq",
                                        "nativeSrc": "6249:2:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "6249:2:5"
                                      },
                                      "nativeSrc": "6249:18:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "6249:18:5"
                                    },
                                    {
                                      "arguments": [
                                        {
                                          "arguments": [],
                                          "functionName": {
                                            "name": "returndatasize",
                                            "nativeSrc": "6276:14:5",
                                            "nodeType": "YulIdentifier",
                                            "src": "6276:14:5"
                                          },
                                          "nativeSrc": "6276:16:5",
                                          "nodeType": "YulFunctionCall",
                                          "src": "6276:16:5"
                                        }
                                      ],
                                      "functionName": {
                                        "name": "iszero",
                                        "nativeSrc": "6269:6:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "6269:6:5"
                                      },
                                      "nativeSrc": "6269:24:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "6269:24:5"
                                    }
                                  ],
                                  "functionName": {
                                    "name": "or",
                                    "nativeSrc": "6246:2:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "6246:2:5"
                                  },
                                  "nativeSrc": "6246:48:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "6246:48:5"
                                },
                                {
                                  "arguments": [
                                    {
                                      "arguments": [],
                                      "functionName": {
                                        "name": "gas",
                                        "nativeSrc": "6617:3:5",
                                        "nodeType": "YulIdentifier",
                                        "src": "6617:3:5"
                                      },
                                      "nativeSrc": "6617:5:5",
                                      "nodeType": "YulFunctionCall",
                                      "src": "6617:5:5"
                                    },
                                    {
                                      "name": "token",
                                      "nativeSrc": "6624:5:5",
                                      "nodeType": "YulIdentifier",
                                      "src": "6624:5:5"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "6631:1:5",
                                      "nodeType": "YulLiteral",
                                      "src": "6631:1:5",
                                      "type": "",
                                      "value": "0"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "6634:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "6634:4:5",
                                      "type": "",
                                      "value": "0x1c"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "6640:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "6640:4:5",
                                      "type": "",
                                      "value": "0x64"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "6646:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "6646:4:5",
                                      "type": "",
                                      "value": "0x00"
                                    },
                                    {
                                      "kind": "number",
                                      "nativeSrc": "6652:4:5",
                                      "nodeType": "YulLiteral",
                                      "src": "6652:4:5",
                                      "type": "",
                                      "value": "0x20"
                                    }
                                  ],
                                  "functionName": {
                                    "name": "call",
                                    "nativeSrc": "6612:4:5",
                                    "nodeType": "YulIdentifier",
                                    "src": "6612:4:5"
                                  },
                                  "nativeSrc": "6612:45:5",
                                  "nodeType": "YulFunctionCall",
                                  "src": "6612:45:5"
                                }
                              ],
                              "functionName": {
                                "name": "and",
                                "nativeSrc": "6034:3:5",
                                "nodeType": "YulIdentifier",
                                "src": "6034:3:5"
                              },
                              "nativeSrc": "6034:641:5",
                              "nodeType": "YulFunctionCall",
                              "src": "6034:641:5"
                            }
                          ],
                          "functionName": {
                            "name": "iszero",
                            "nativeSrc": "6010:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "6010:6:5"
                          },
                          "nativeSrc": "6010:679:5",
                          "nodeType": "YulFunctionCall",
                          "src": "6010:679:5"
                        },
                        "nativeSrc": "6007:895:5",
                        "nodeType": "YulIf",
                        "src": "6007:895:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "6923:4:5",
                              "nodeType": "YulLiteral",
                              "src": "6923:4:5",
                              "type": "",
                              "value": "0x60"
                            },
                            {
                              "kind": "number",
                              "nativeSrc": "6929:1:5",
                              "nodeType": "YulLiteral",
                              "src": "6929:1:5",
                              "type": "",
                              "value": "0"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "6916:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "6916:6:5"
                          },
                          "nativeSrc": "6916:15:5",
                          "nodeType": "YulFunctionCall",
                          "src": "6916:15:5"
                        },
                        "nativeSrc": "6916:15:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "6916:15:5"
                      },
                      {
                        "expression": {
                          "arguments": [
                            {
                              "kind": "number",
                              "nativeSrc": "6985:4:5",
                              "nodeType": "YulLiteral",
                              "src": "6985:4:5",
                              "type": "",
                              "value": "0x40"
                            },
                            {
                              "name": "memPointer",
                              "nativeSrc": "6991:10:5",
                              "nodeType": "YulIdentifier",
                              "src": "6991:10:5"
                            }
                          ],
                          "functionName": {
                            "name": "mstore",
                            "nativeSrc": "6978:6:5",
                            "nodeType": "YulIdentifier",
                            "src": "6978:6:5"
                          },
                          "nativeSrc": "6978:24:5",
                          "nodeType": "YulFunctionCall",
                          "src": "6978:24:5"
                        },
                        "nativeSrc": "6978:24:5",
                        "nodeType": "YulExpressionStatement",
                        "src": "6978:24:5"
                      }
                    ]
                  },
                  "documentation": "@solidity memory-safe-assembly",
                  "evmVersion": "shanghai",
                  "externalReferences": [
                    {
                      "declaration": 7888,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "5953:6:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7884,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "5833:4:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7886,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "5895:2:5",
                      "valueSize": 1
                    },
                    {
                      "declaration": 7882,
                      "isOffset": false,
                      "isSlot": false,
                      "src": "6624:5:5",
                      "valueSize": 1
                    }
                  ],
                  "id": 7891,
                  "nodeType": "InlineAssembly",
                  "src": "5538:1501:5"
                }
              ]
            },
            "documentation": {
              "id": 7880,
              "nodeType": "StructuredDocumentation",
              "src": "5181:207:5",
              "text": "@dev Sends `amount` of ERC20 `token` from `from` to `to`.\n Reverts upon failure.\n The `from` account must have at least `amount` approved for\n the current contract to manage."
            },
            "id": 7893,
            "implemented": true,
            "kind": "function",
            "modifiers": [],
            "name": "safeTransferFrom",
            "nameLocation": "5402:16:5",
            "nodeType": "FunctionDefinition",
            "parameters": {
              "id": 7889,
              "nodeType": "ParameterList",
              "parameters": [
                {
                  "constant": false,
                  "id": 7882,
                  "mutability": "mutable",
                  "name": "token",
                  "nameLocation": "5427:5:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7893,
                  "src": "5419:13:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7881,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "5419:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7884,
                  "mutability": "mutable",
                  "name": "from",
                  "nameLocation": "5442:4:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7893,
                  "src": "5434:12:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7883,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "5434:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7886,
                  "mutability": "mutable",
                  "name": "to",
                  "nameLocation": "5456:2:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7893,
                  "src": "5448:10:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_address",
                    "typeString": "address"
                  },
                  "typeName": {
                    "id": 7885,
                    "name": "address",
                    "nodeType": "ElementaryTypeName",
                    "src": "5448:7:5",
                    "stateMutability": "nonpayable",
                    "typeDescriptions": {
                      "typeIdentifier": "t_address",
                      "typeString": "address"
                    }
                  },
                  "visibility": "internal"
                },
                {
                  "constant": false,
                  "id": 7888,
                  "mutability": "mutable",
                  "name": "amount",
                  "nameLocation": "5468:6:5",
                  "nodeType": "VariableDeclaration",
                  "scope": 7893,
                  "src": "5460:14:5",
                  "stateVariable": false,
                  "storageLocation": "default",
                  "typeDescriptions": {
                    "typeIdentifier": "t_uint256",
                    "typeString": "uint256"
                  },
                  "typeName": {
                    "id": 7887,
                    "name": "uint256",
                    "nodeType": "ElementaryTypeName",
                    "src": "5460:7:5",
                    "typeDescriptions": {
                      "typeIdentifier": "t_uint256",
                      "typeString": "uint256"
                    }
                  },
                  "visibility": "internal"
                }
              ],
              "src": "5418:57:5"
            },
            "returnParameters": {
              "id": 7890,
              "nodeType": "ParameterList",
              "parameters": [],
              "src": "5485:0:5"
            },
            "scope": 7894,
            "src": "5393:1652:5",
            "stateMutability": "nonpayable",
            "virtual": false,
            "visibility": "internal"
          }
        ],
        "scope": 7895,
        "src": "469:6578:5",
        "usedErrors": [
          7836,
          7839,
          7842,
          7845
        ],
        "usedEvents": []
      }
    ],
    "src": "32:7016:5"
  },
  "compiler": {
    "name": "solc",
    "version": "0.8.28+commit.7893614a.Linux.g++"
  },
  "networks": {},
  "schemaVersion": "3.4.16",
  "updatedAt": "2025-02-12T06:30:13.803Z",
  "devdoc": {
    "author": "SolDAO (https://github.com/Sol-DAO/solbase/blob/main/src/utils/SafeTransferLib.sol)Modified from Solady (https://github.com/vectorized/solady/blob/main/src/utils/SafeTransferLib.sol)",
    "details": "Caution! This library won't check that a token has code, responsibility is delegated to the caller.",
    "errors": {
      "ApproveFailed()": [
        {
          "details": "The ERC20 `approve` has failed."
        }
      ],
      "ETHTransferFailed()": [
        {
          "details": "The ETH transfer has failed."
        }
      ],
      "TransferFailed()": [
        {
          "details": "The ERC20 `transfer` has failed."
        }
      ],
      "TransferFromFailed()": [
        {
          "details": "The ERC20 `transferFrom` has failed."
        }
      ]
    },
    "kind": "dev",
    "methods": {},
    "version": 1
  },
  "userdoc": {
    "kind": "user",
    "methods": {},
    "notice": "Safe ETH and ERC20 transfer library that gracefully handles missing return values.",
    "version": 1
  }
}